// js class example
class Rectangle {
  constructor(height, width) {
    this.height = height;
    this.width = width;
  }
}

class NODE:
	def __init__(self, id, left, right, parent, depth, kind, text, relname, relkind):

		"""Basic class to hold all nodes (EDU, span and multinuc) in structure.py and while importing"""

		self.id = id
		self.parent = parent
		self.left = left
		self.right = right
		self.depth = depth
		self.kind = kind #edu, multinuc or span node
		self.text = text #text of an edu node; empty for spans/multinucs
		self.relname = relname
		self.relkind = relkind #rst (a.k.a. satellite), multinuc or span relation
		self.sortdepth = depth

function read_rst(rs3_string){

	xmldoc = minidom.parseString(rs3_string); //TODO: choose javascript XML parser

	// error handling

	nodes = [];
	ordered_id = {};
	schemas = [];
	default_rst = "";

	// Get relation names and their types, append type suffix to disambiguate
	// relation names that can be both RST and multinuc
	????item_list = xmldoc.getElementsByTagName("rel")
	for (rel of item_list){
		relname = re.sub(r"[:;,]","",rel.attributes["name"].value);
		relname = //get name attr from xml element
		relname = relname.replace(/[:;,]/,'');
		if (rel.hasAttribute("type")) { // CHECK js XML parser
			rel_hash[relname+"_"+rel.attributes["type"].value[0:1]] = rel.attributes["type"].value
			if rel.attributes["type"].value == "rst" and default_rst=="":
				default_rst = relname+"_"+rel.attributes["type"].value[0:1]
		else:  # This is a schema relation
			schemas.append(relname)
	}

	item_list = xmldoc.getElementsByTagName("segment")
	if len(item_list) < 1:
		return '<div class="warn">No segment elements found in .rs3 file</div>'

	id_counter = 0
	total_toks = 0

	# Get hash to reorder EDUs and spans according to the order of appearance in .rs3 file
	for segment in item_list:
		id_counter += 1
		ordered_id[segment.attributes["id"].value] = id_counter
	item_list = xmldoc.getElementsByTagName("group")
	for group in item_list:
		id_counter += 1
		ordered_id[group.attributes["id"].value] = id_counter
	all_node_ids = set(range(1,id_counter+1))  # All non-zero IDs in documents, which a signal may refer back to
	ordered_id["0"] = 0

	element_types={}
	node_elements = xmldoc.getElementsByTagName("segment")
	for element in node_elements:
		element_types[element.attributes["id"].value] = "edu"
	node_elements = xmldoc.getElementsByTagName("group")
	for element in node_elements:
		element_types[element.attributes["id"].value] = element.attributes["type"].value

	# Collect all children of multinuc parents to prioritize which potentially multinuc relation they have
	item_list = xmldoc.getElementsByTagName("segment") + xmldoc.getElementsByTagName("group")
	multinuc_children = collections.defaultdict(lambda : collections.defaultdict(int))
	for elem in item_list:
		if elem.attributes.length >= 3:
			parent = elem.attributes["parent"].value
			relname = elem.attributes["relname"].value
			# Tolerate schemas by treating as spans
			if relname in schemas:
				relname = "span"
			relname = re.sub(r"[:;,]", "", relname)  # Remove characters used for undo logging, not allowed in rel names
			if parent in element_types:
				if element_types[parent] == "multinuc" and relname+"_m" in rel_hash:
					multinuc_children[parent][relname] += 1

	id_counter = 0
	item_list = xmldoc.getElementsByTagName("segment")
	for segment in item_list:
		id_counter += 1
		if segment.hasAttribute("parent"):
			parent = segment.attributes["parent"].value
		else:
			parent = "0"
		if segment.hasAttribute("relname"):
			relname = segment.attributes["relname"].value
		else:
			relname = default_rst

		# Tolerate schemas, but no real support yet:
		if relname in schemas:
			relname = "span"
			relname = re.sub(r"[:;,]","",relname) #remove characters used for undo logging, not allowed in rel names

		# Note that in RSTTool, a multinuc child with a multinuc compatible relation is always interpreted as multinuc
		if parent in multinuc_children:
			if len(multinuc_children[parent]) > 0:
				key_list = list(iterkeys(multinuc_children[parent]))[:]
				for key in key_list:
					if multinuc_children[parent][key] < 2:
						del multinuc_children[parent][key]

		if parent in element_types:
			if element_types[parent] == "multinuc" and relname + "_m" in rel_hash and (
					relname in multinuc_children[parent] or len(multinuc_children[parent]) == 0):
				relname = relname + "_m"
			elif relname != "span":
				relname = relname + "_r"
		else:
			if not relname.endswith("_r") and len(relname)>0:
				relname = relname+"_r"
		edu_id = segment.attributes["id"].value
		if len(segment.childNodes) > 0:  # Check the node is not empty
			contents = segment.childNodes[0].data.strip()
			if len(contents) == 0:
				continue
		else:
			continue

		# Check for invalid XML in segment contents
		if "<" in contents or ">" in contents or "&" in contents:
			contents = contents.replace('>','&gt;')
			contents = contents.replace('<', '&lt;')
			contents = re.sub(r'&([^ ;]* )', r'&amp;\1', contents)
			contents = re.sub(r'&$', r'&amp;', contents)
		if do_tokenize:
			contents = tokenize(contents)
			contents = " ".join(contents.strip().split("\n"))

		total_toks += contents.strip().count(" ") + 1
		nodes.append([str(ordered_id[edu_id]), id_counter, id_counter, str(ordered_id[parent]), 0, "edu", contents, relname])

	item_list = xmldoc.getElementsByTagName("group")
	for group in item_list:
		if group.attributes.length == 4:
			parent = group.attributes["parent"].value
		else:
			parent = "0"
		if group.attributes.length == 4:
			relname = group.attributes["relname"].value
			# Tolerate schemas by treating as spans
			if relname in schemas:
				relname = "span"
				
			relname = re.sub(r"[:;,]","",relname)  # Remove characters used for undo logging, not allowed in rel names

			# Note that in RSTTool, a multinuc child with a multinuc compatible relation is always interpreted as multinuc
			if parent in multinuc_children:
				if len(multinuc_children[parent])>0:
					key_list = list(iterkeys(multinuc_children[parent]))[:]
					for key in key_list:
						if multinuc_children[parent][key] < 2:
							del multinuc_children[parent][key]

			if parent in element_types:
				if element_types[parent] == "multinuc" and relname+"_m" in rel_hash and (relname in multinuc_children[parent] or len(multinuc_children[parent]) == 0):
					relname = relname+"_m"
				elif relname !="span":
					relname = relname+"_r"
			else:
				relname = ""
		else:
			relname = ""
		group_id = group.attributes["id"].value
		group_type = group.attributes["type"].value
		contents = ""
		nodes.append([str(ordered_id[group_id]),0,0,str(ordered_id[parent]),0,group_type,contents,relname])

	# Collect discourse signal annotations if any are available
	item_list = xmldoc.getElementsByTagName("signal")
	signals = []
	for signal in item_list:
		source = signal.attributes["source"].value
		# This will crash if signal source refers to a non-existing node:
		source = ordered_id[source]
		if source not in all_node_ids:
			raise IOError("Invalid source node ID for signal: " + str(source) + " (from XML file source="+signal.attributes["source"].value+"(\n")
		type = signal.attributes["type"].value
		subtype = signal.attributes["subtype"].value
		tokens = signal.attributes["tokens"].value
		if tokens != "":
			# This will crash if tokens contains non-numbers:
			token_list = [int(tok) for tok in tokens.split(",")]
			max_tok = max(token_list)
			if max_tok > total_toks:
				raise IOError("Signal refers to non-existent token: " + str(max_tok))
		signals.append([str(source),type,subtype,tokens])

	elements = {}
	for row in nodes:
		elements[row[0]] = NODE(row[0],row[1],row[2],row[3],row[4],row[5],row[6],row[7],"")

	for element in elements:
		if elements[element].kind == "edu":
			get_left_right(element, elements,0,0,rel_hash)

	return elements, signals
}
